% This script will crate automatically
% the TCL files for building 
% parameters, inputs and outputs trees, using SPC mds-matlab-structs
% functions (liked in a git submodule)
%
% it is assumed that the main algo_cfs2_tp
% structure is already present in the base workspace
%
% if successfully executed the three generated TCL scripts:
% /tmp/<username>/cfs2_tp.tcl
% /tmp/<username>/cfs2_inbus.tcl
% /tmp/<username>/cfs2_outbus.tcl
% can be executed by a MDSplus tree edit enabled user via:
% cat /tmp/<username>/cfs2_tp.tcl | mdstcl
% and so on

addpath ../../mds/mds-matlab-structs

%% tunable parameters
tpsrc=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_tp_tmpl').Value;
tpsrcpad=struct();
tpsrcpad.cfs2.params=tpsrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(tpsrcpad,'cfs2_tp.tcl','scdds','value')
clear tpsrc tpsrcpad

%% input bus
inbus=Simulink.data.evalinGlobal('algo_cfs2','WG0601bus');
inbussrc=Simulink.Bus.createMATLABStruct('inbus');
inbussrcpad.cfs2.inputs=inbussrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(inbussrcpad,'cfs2_inbus.tcl','scdds','data','full_name','dim','signal')
clear inbus inbussrc inbussrcpad

%% output bus
algo_cfs2_outBus=Simulink.data.evalinGlobal('algo_cfs2','algo_cfs2_outBus');
outbus=Simulink.data.evalinGlobal('algo_cfs2','mdsout02');
outbussrc=Simulink.Bus.createMATLABStruct('outbus');
outbussrcpad.cfs2.outputs=outbussrc;
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(outbussrcpad,'cfs2_outbus.tcl','scdds','data','full_name','dim','signal')
clear outbus outbussrc outbussrcpad

%% metadata channels
metach.cfs2.system.ch01=single(0);
metach.cfs2.system.ch02=single(0);
metach.cfs2.system.ch03=single(0);
metach.cfs2.system.ch04=single(0);
[status_out,struct_out_ala_mds,fname_out]=...
    mds_create_nodes(metach,'cfs2_system.tcl','scdds','data','full_name','dim','signal')
clear metach

